﻿using System;
using System.Collections;
namespace Plywood {
    public struct Binary : IEnumerable {

        private bool[] p_Binary;

        public void Reverse() { 
            //Define the buffer to set to
            bool[] buffer = new bool[Length];

            //Fill in the buffer with the opposite values
            for (int c = 0; c < buffer.Length; c++) {
                buffer[c] = p_Binary[p_Binary.Length - 1 - c];
            }

            //Set the binary value
            p_Binary = buffer;
        }
        public void Invert() { 
            //Loop through the entries
            for (int c = 0; c < Length; c++) { 
                //Invert the entry value
                p_Binary[c] = !p_Binary[c];
            }
        }

        public static implicit operator bool[](Binary obj) {
            return obj.p_Binary;
        }
        public static implicit operator string(Binary obj) {
            return obj.ToString();
        }
        public static implicit operator Binary(bool[] obj) {
            return new Binary { p_Binary = obj };
        }
        public static implicit operator Binary(string value) { 
            //Define the boolean array to work with
            bool[] buffer = new bool[value.Length];

            //Loop throught the values
            for (int c = 0; c < buffer.Length; c++) { 
                //Check the value
                if (value[c] != '1' && value[c] != '0') {
                    throw new Exception("Invalid binary value");
                }

                //Apply the appropriate value into the buffer
                buffer[c] = value[c] == '1';
            }

            //Return the return buffer
            return buffer;
        }
        public static bool operator ==(Binary b1, Binary b2) { 
            //Return equal result
            return b1.Equals(b2);
        }
        public static bool operator !=(Binary b1, Binary b2) { 
            //Return the inverted equal value
            return !(b1 == b2);
        }

        public IEnumerator GetEnumerator() { 
            //Just return the boolean array enumerator
            return p_Binary.GetEnumerator();
        }

        public long Length { get { return p_Binary.Length; } }

        public override string ToString() {
            //Define the return buffer
            string buffer = "";

            //Fill in the buffer
            foreach (bool b in p_Binary) {
                buffer += (b ? "1" : "0");
            }

            //Return the buffer
            return buffer;
        }
        public override bool Equals(object obj) {            
            //Is the object a binary type?
            if (!(obj is Binary)) { return false; } 
            
            //Compare the binary
            return (NumericOperations.FromBinary((Binary)obj) ==
                    NumericOperations.FromBinary(this));
        }
    }
}