﻿using System;
using System.Reflection;

namespace Plywood {
    public class ClrMethod : IMethod {
        private MethodInfo p_BaseMethod;
        public ClrMethod(MethodInfo methodInfo) { 
            //Define the globals
            p_BaseMethod = methodInfo;
        }

        public object AssignedInstance { get; set; }
        public string Name { get { return p_BaseMethod.Name; } }
        public Type[] ArgumentTypes { get { 
            //Get the clr parameters
            ParameterInfo[] argTypes = p_BaseMethod.GetParameters();

            //Define the return buffer
            Type[] buffer = new Type[argTypes.Length];

            //Fill in the buffer with the types
            for (int c = 0; c < buffer.Length; c++) {
                buffer[c] = argTypes[c].ParameterType;
            }

            //Return the buffer
            return buffer;
        } }

        public object Invoke(object[] args) { return Invoke(AssignedInstance, args); }
        public object Invoke(object instance, object[] args) { 
            //Invoke the clr method
            return p_BaseMethod.Invoke(instance, args); 
            return null;
        }

        public Type ReturnType { get { return p_BaseMethod.ReturnType; } }

        public bool IgnoreLogicalArgument(int argIndex) {
            //Let the generic method class handle this
            return GenericMethods.IgnoreLogicPass(Name);
        }

        public override string ToString() {
            return Name;
        }
    }
}