﻿using System;
using System.IO;

namespace Plywood {
    public static class Encryption {
        private static _keyChar[] p_Characters;
        
        static Encryption() {
            //Define the encryption key characters
            p_Characters = new _keyChar[] {
                new _keyChar('a', delegate(int v, int keyLength, int position) { return 10; }),
                new _keyChar('A', delegate(int v, int keyLength, int position) { return 14; }),
                new _keyChar('b', delegate(int v, int keyLength, int position) { return keyLength / 2; }),
                new _keyChar('Z', delegate(int v, int keyLength, int positionh) { return keyLength % 3; }),
                new _keyChar('d', delegate(int v, int keyLength, int position) { return 50; }),
                new _keyChar('W', delegate(int v, int keyLength, int position) { return 20; }),
                new _keyChar('F', delegate(int v, int keyLength, int position) { return 102; }),
                new _keyChar('e', delegate(int v, int keyLength, int position) { return keyLength ^ 3; }),
                new _keyChar('E', delegate(int v, int keyLength, int position) { return 35; }),
                new _keyChar('p', delegate(int v, int keyLength, int position) { return 90; }),
                new _keyChar('P', delegate(int v, int keyLength, int position) { return 1; }),
                new _keyChar('s', delegate(int v, int keyLength, int position) { return -keyLength / 2; }),
                new _keyChar('S', delegate(int v, int keyLength, int position) { return -200; }),
                new _keyChar('x', delegate(int v, int keyLength, int position) { return 60; }),
                new _keyChar('X', delegate(int v, int keyLength, int position) { return -10; }),
                new _keyChar('z', delegate(int v, int keyLength, int position) { return -keyLength * 4; }),
                new _keyChar('h', delegate(int v, int keyLength, int position) { return -position; }),
                new _keyChar('o', delegate(int v, int keyLength, int position) { return -position * 4; }),
                new _keyChar('O', delegate(int v, int keyLength, int position) { return 30 * position / 20; }),
                new _keyChar('H', delegate(int v, int keyLength, int position) { return position; }),
                new _keyChar('B', delegate(int v, int keyLength, int position) { return position / 2; }),
                new _keyChar('C', delegate(int v, int keyLength, int position) { return position / 3; }),
                new _keyChar('D', delegate(int v, int keyLength, int position) { return position / 4; }),
                new _keyChar('G', delegate(int v, int keyLength, int position) { return position / 5; }),
                new _keyChar('I', delegate(int v, int keyLength, int position) { return position / 6; }),                
                new _keyChar('J', delegate(int v, int keyLength, int position) { return position * 2; }),
                new _keyChar('K', delegate(int v, int keyLength, int position) { return position * keyLength; }),
                new _keyChar('L', delegate(int v, int keyLength, int position) { return position * (keyLength / 2); }),
                new _keyChar('M', delegate(int v, int keyLength, int position) { return position ^ 3; }),
                new _keyChar('N', delegate(int v, int keyLength, int position) { return position * 3; }),
                new _keyChar('Q', delegate(int v, int keyLength, int position) { return position % 3; }),
                new _keyChar('R', delegate(int v, int keyLength, int position) { return position % 2; }),
                new _keyChar('T', delegate(int v, int keyLength, int position) { return position % 1; }),
                new _keyChar('U', delegate(int v, int keyLength, int position) { return position % 4; }),
                new _keyChar('V', delegate(int v, int keyLength, int position) { return position / 7; }),
                new _keyChar('Y', delegate(int v, int keyLength, int position) { return position / 8; }),                
                new _keyChar('c', delegate(int v, int keyLength, int position) { return 120; }),
                new _keyChar('f', delegate(int v, int keyLength, int position) { return 230; }),
                new _keyChar('g', delegate(int v, int keyLength, int position) { return 3; }),
                new _keyChar('i', delegate(int v, int keyLength, int position) { return 255; }),
                new _keyChar('j', delegate(int v, int keyLength, int position) { return 15; }),
                new _keyChar('k', delegate(int v, int keyLength, int position) { return 99; }),
                new _keyChar('l', delegate(int v, int keyLength, int position) { return 83; }),
                new _keyChar('m', delegate(int v, int keyLength, int position) { return 127; }),
                new _keyChar('n', delegate(int v, int keyLength, int position) { return 23; }),
                new _keyChar('q', delegate(int v, int keyLength, int position) { return 45; }),
                new _keyChar('r', delegate(int v, int keyLength, int position) { return 140; }),
                new _keyChar('t', delegate(int v, int keyLength, int position) { return 203; }),
                new _keyChar('u', delegate(int v, int keyLength, int position) { return 6; }),
                new _keyChar('v', delegate(int v, int keyLength, int position) { return 8; }),
                new _keyChar('w', delegate(int v, int keyLength, int position) { return 9; }),
                new _keyChar('y', delegate(int v, int keyLength, int position) { return 11; }),
                
            };
        }

        public static char GetEncryptionChar(int index) { 
            //Return the associated character
            return p_Characters[index].Character;
        }

        public static void Encrypt(Stream read, Stream write, string key) {   
            //Check the key
            if (!ValidKey(key)) {
                throw new Exception("Invalid key");
            }

            //Define the callback
            getByteCallback callback = delegate(byte b) {
                //Apply the key to the byte
                for(int x = 0; x < key.Length; x++) {
                    char c = key[x];
                    foreach (_keyChar ch in p_Characters) {
                        if (ch.Character == c) { b += (byte)ch.onIncroment((byte)b, key.Length, x); break; }
                    }
                }

                //Return the byte
                return b;
            };

            //Perform write
            writeCallbackHandle(callback, read, write);
        }
        public static void Encrypt(Stream read, string key) { 
            //Let the local method handle this
            Encrypt(read, new _oneByteWrite { BaseStream = read }, key);
        }
        public static void Decrypt(Stream read, Stream write, string key) {  
            //Check the key
            if (!ValidKey(key)) {
                throw new Exception("Invalid key");
            }

            //Define the callback
            getByteCallback callback = delegate(byte b) { 
                //Apply the opposite of the key passed
                for(int x = 0; x < key.Length; x++) {
                    char c = key[x];
                    foreach (_keyChar ch in p_Characters) {
                        if (ch.Character == c) { b -= (byte)ch.onIncroment((byte)b, key.Length, x); break; }
                    }
                }

                //Return the byte
                return b;
            };

            //Perform the write
            writeCallbackHandle(callback, read, write);
        }
        public static void Decrypt(Stream read, string key) { 
            //Let the local method handle this
            Decrypt(read, new _oneByteWrite { BaseStream = read }, key);
        }

        public static void Encrypt(ref byte[] stack, string key) { 
            //Write the stack to a temporary memory stream
            Stream str = new MemoryStream();
            str.Write(stack, 0, stack.Length);
            str.Position = 0;
            
            //Encrypt the stack
            Encrypt(str, key);

            //Read the data back into the stack
            str.Position = 0;
            str.Read(stack, 0, stack.Length);

            //Clean up
            str.Close();
        }
        public static void Decrypt(ref byte[] stack, string key) { 
            //Read the stack to temporary stream
            Stream str = new MemoryStream();
            str.Write(stack, 0, stack.Length);
            str.Position = 0;

            //Decrypt the stream
            Decrypt(str, key);

            //Push the data back to the stack
            str.Position = 0;
            str.Read(stack, 0, stack.Length);

            //Clean up
            str.Close();
        }

        public static bool ValidKey(string key) {
            //Loop through the characters
            foreach (char c in key) { 
                //Is this character valid?
                bool valid = false;
                foreach (_keyChar x in p_Characters) {
                    if (x.Character == c) { valid = true; }
                }

                //Is the character valid?
                if (!valid) { return false; }
            }

            //Everything was found
            return true;
        }
        public static string GenerateKey(int length) { 
            //Define the random value
            Random r = new Random();

            //Define the return buffer
            string buffer = "";

            //Loop through the length
            for (int c = 0; c < length; c++) {
                buffer += p_Characters[r.Next(0, p_Characters.Length)].Character;
            }

            //Return the buffer
            return buffer;
        }

        private static void writeCallbackHandle(getByteCallback callback, Stream read, Stream write) { 
            //Check the read and write stream
            if (!read.CanRead || !write.CanWrite) {
                throw new Exception("Invalid streams");
            }

            //Define how many bytes are left in the read stream
            long length = read.Length - read.Position;

            //Loop through the bytes from the read stream
            for (long c = 0; c < length; c++) { 
                //Grab the callback response for this byte
                byte r = callback((byte)read.ReadByte());

                //Write the byte to the write stream
                write.WriteByte(r);
            }
        }

        private delegate byte getByteCallback(byte bValue);

        private class _keyChar
        {
            public char Character { get; set; }
            public incrimentValHandler onIncroment { get; set; }

            public _keyChar(char character, incrimentValHandler handler) { 
                //Define the globals
                Character = character;
                onIncroment = handler;
            }

            public delegate int incrimentValHandler(int v, int keyLength, int position);
        }
        private class _oneByteWrite : Stream {
            public Stream BaseStream;

            public override bool CanRead { get { return false; } }
            public override bool CanWrite { get { return true; } }
            public override bool CanSeek { get { return false; } }
            public override long Position {
                get {
                    throw new NotSupportedException();
                }
                set {
                    throw new NotSupportedException();
                }
            }
            public override long Length { get { throw new NotSupportedException(); } }

            public override long Seek(long offset, SeekOrigin origin) {
                throw new NotSupportedException();
            }
            public override void SetLength(long value) {
                throw new NotSupportedException();
            }
            public override void Flush() {
                throw new NotSupportedException();
            }
            public override int Read(byte[] buffer, int offset, int count) {
                throw new NotSupportedException();
            }
            public override int ReadByte() {
                throw new NotSupportedException();
            }
            public override void Write(byte[] buffer, int offset, int count) {
                throw new NotSupportedException();
            }
            public override void WriteByte(byte value) {
                //Push back the write stream
                if (BaseStream.Position > 0) { BaseStream.Seek(-1, SeekOrigin.Current); }

                //Write the byte
                BaseStream.WriteByte(value);
            }
        }
    }
}