﻿using System;
using System.Collections;


namespace Plywood {
    public partial class GenericMethods {
        public char charFromInt(long v) {
            return (char)v;
        }
        public long intFromChar(string c) { return (long)c[0]; }
        public string changeBase(string value, long baseFrom, long baseTo) {
            //Get the numeric value of the value passed
            Binary binary;
            switch (baseFrom) {
                case 2: binary = value; break;
                case 10: binary = NumericOperations.ToBinary((ulong)Convert.ToInt64(value)); break;
                case 16: binary = NumericOperations.FromHex(value); break;
                default:
                    throw new Exception("Invalid source base");
            }


            //Return the conversion
            switch (baseTo) {
                case 2: return binary;
                case 10: return NumericOperations.FromBinary(binary).ToString();
                case 16: return NumericOperations.ToHex(binary);
                default:
                    throw new Exception("Invalid destination base");
            }
        }
        public string decToHex(long value) { return changeBase(value.ToString(), 10, 16); }
        public string decToBin(long value) { return changeBase(value.ToString(), 10, 2); }
        public string binToHex(string binary) { return changeBase(binary, 2, 16); }
        public long binToDec(string binary) { return Convert.ToInt64(changeBase(binary, 2, 10)); }
        public long hexToDec(string hex) { return Convert.ToInt64(changeBase(hex, 16, 10)); }
        public string hexToBin(string hex) { return changeBase(hex, 16, 2); }
        public string stringFromArray(string definition) {
            //Get the array
            object[] array = (object[])p_State.Script.getDefByName(definition).ArrayList;

            //Convert the array to a string
            string buffer = "";
            foreach (object o in array) {
                buffer += (char)Convert.ToByte(o);
            }
            return buffer;
        }
        public long arrayFromString(string str) { 
            //Define the array
            p_State.CurrentDefinition.Value = "ARRAY_DEF";
            p_State.CurrentDefinition.IsNumeric = false;
            p_State.ApplyDefinitionGlobal = true;

            //Get the array version of the string
            object[] array = new object[str.Length];
            for (int c = 0; c < array.Length; c++) {
                array[c] = str[c];
            }

            //Push the array to the definition
            p_State.CurrentDefinition.ArrayList = (IList)array;
            return 0;
        }
        
    }
}