﻿using System;
using System.Reflection;
namespace Plywood {
    public partial class GenericMethods {

        private static delegateObj[] p_Delegates = new delegateObj[0];

        public long delegate_create(string meth) {
            //Hang
            while (delegateObj.Hang) ;
            delegateObj.Hang = true;

            //Get the method info
            IMethod method = null;
            foreach (IMethod m in p_State.Script.p_Methods) {
                if (m.Name == meth) { method = m; break; }
            }

            //Found?
            if (method == null) {
                throw new Exception("Method was not found");
            }

            //Get the argument types
            Type[] arguments = method.ArgumentTypes;

            //Get the delegate
            Type callbackType = null;
            FieldInfo callback = null;
            Delegate del = DynamicLibraryLoader.GetDynamicDelegate(method.ReturnType, method.ArgumentTypes, out callbackType, out callback);
            
            //Set the callback field
            MethodInfo callMethod = typeof(GenericMethods).GetMethod("methodCallbackHandler", BindingFlags.NonPublic | BindingFlags.Instance);
            callback.SetValue(null, Delegate.CreateDelegate(callbackType, this, callMethod));

            //Stop hang
            delegateObj.Hang = false;

            //Add the delegate
            return addDelegateObj(del, callbackType, callback, method);                     
        }
        public void delegate_remove(long id) { 
            //Hang
            while (delegateObj.Hang) ;
            delegateObj.Hang = true;

            //Define the new buffer
            delegateObj[] buffer = new delegateObj[p_Delegates.Length - 1];
            int ai = 0;
            bool found = false;

            //Remove the id
            for (int c = 0; c < p_Delegates.Length; c++) {
                if (p_Delegates[c].ID == id) { found = true; continue; }
                buffer[ai] = p_Delegates[c];
                ai++;
            }

            //Set the globals
            p_Delegates = buffer;

            //Stop hang
            delegateObj.Hang = false;
        }
        public string delegate_invoke(string did, params object[] param) { 
            //Get the delegate 
            long id = Convert.ToInt64(p_State.Script.getValueFromRaw(did, p_State));
            delegateObj del = getDelegateObject(id);
            param = clrConvMethodTypes(param, del.Method.ArgumentTypes);

            //Add the method info onto the end
            Array.Resize(ref param, param.Length + 1);
            param[param.Length - 1] = del.Method;

            //Invoke it
            object o = del.Delegate.DynamicInvoke(param).ToString();
            return o == null ? "" : o.ToString();
        }

        private long addDelegateObj(Delegate del, Type callbackType, FieldInfo field, IMethod method) { 
            //Grab the max index
            long maxId = 0;
            foreach (delegateObj d in p_Delegates) {
                if (d.ID >= maxId) { maxId = d.ID + 1; }
            }

            //Add the object
            Array.Resize(ref p_Delegates, p_Delegates.Length + 1);
            p_Delegates[p_Delegates.Length - 1] = new delegateObj { 
                ID = maxId,
                Delegate = del,
                CallbackField = field,
                CallbackType = callbackType,
                Method = method
            }; 

            //Return the id
            return maxId;
        }
        private delegateObj getDelegateObject(long id) { 
            //Search for the id
            foreach (delegateObj o in p_Delegates) {
                if (o.ID == id) { return o; }
            }

            //Not found
            throw new Exception("Not found");
        }
        private object methodCallbackHandler(object[] param, IMethod method) { 
            //Just invoke the method
            return method.Invoke(this, param);
        }

        private class delegateObj {
            public long ID;
            public Delegate Delegate;
            public FieldInfo CallbackField;
            public Type CallbackType;
            public IMethod Method;

            public static bool Hang;
        }
    }
}