﻿using System;
using System.Collections;
using System.Management;

namespace Plywood {
    public partial class GenericMethods {
        private static mObj[] p_ManagementObjects = new mObj[0];

        public long manage_addSearcher(string query) { 
            //Create the object
            return addManagementObject(new ManagementObjectSearcher(query));
        }
        public object manage_getValue(long mid, string name) { 
            //Return the value
            return ((ManagementObject)getManagementObject(mid).Instance)[name];
        }
        public long manage_get(long mid) { 
            //Define the objects to push to the definition
            object[] array = new object[0];
            
            //Fill in
            foreach (ManagementObject o in ((ManagementObjectSearcher)getManagementObject(mid).Instance).Get()) {
                Array.Resize(ref array, array.Length + 1);
                array[array.Length - 1] = addManagementObject(o);
            }

            //Push the object array to the current definition
            p_State.CurrentDefinition.Value = "ARRAY_DEF";
            p_State.CurrentDefinition.IsNumeric = false;
            p_State.CurrentDefinition.ArrayList = (IList)array;
            p_State.ApplyDefinitionGlobal = true;
            return 0;
        }
        public void manage_remove(long mid) {
            //Hang
            while (mObj.Hang) ;
            mObj.Hang = true;

            //Remove the id
            mObj[] buffer = new mObj[p_ManagementObjects.Length - 1];
            int ai = 0;
            bool found = false;
            for (int c = 0; c < p_ManagementObjects.Length; c++) {
                if (p_ManagementObjects[c].ID == mid) { found = true; continue; }
                buffer[ai] = p_ManagementObjects[c];
                ai++;
            }

            //Stop hang
            mObj.Hang = false;

            //Found?
            if (!found) {
                throw new Exception("Management object not found");
            }
        }
        public void manage_removeStack(string arr) { 
            //Get the definition
            IDefinition def = p_State.Script.getDefByName(arr);

            //Remove every entry
            foreach (object o in def.ArrayList) {
                manage_remove((long)o);
            }
        }
        public long manage_getProperties(long mid) { 
            //Get the properties
            PropertyDataCollection props = ((ManagementObject)getManagementObject(mid).Instance).Properties;
        
            //Push into an array
            object[] array = new object[0];
            foreach (PropertyData prop in props) {
                Array.Resize(ref array, array.Length + 1);
                array[array.Length - 1] = prop.Name;
            }

            p_State.CurrentDefinition.Value = "ARRAY_DEF";
            p_State.CurrentDefinition.IsNumeric = false;
            p_State.CurrentDefinition.ArrayList = (IList)array;
            p_State.ApplyDefinitionGlobal = true;
            return 0;
        }
        
        private long addManagementObject(object instance) {
            //Hang
            while (mObj.Hang) ;
            mObj.Hang = true;

            //Get the ID
            long id = 0;
            foreach (mObj m in p_ManagementObjects) {
                if (m.ID >= id) { id = m.ID + 1; }
            }

            //Add the instance
            Array.Resize(ref p_ManagementObjects, p_ManagementObjects.Length + 1);
            p_ManagementObjects[p_ManagementObjects.Length - 1] = new mObj() {
                ID = id,
                Instance = instance
            };

            //Not found
            mObj.Hang = false;

            //Return it's id
            return id;
        }
        private mObj getManagementObject(long mid) { 
            //Hang
            while (mObj.Hang) ;
            mObj.Hang = true;

            //Look for the object
            foreach (mObj m in p_ManagementObjects) {
                if (m.ID == mid) { mObj.Hang = false; return m; }
            }

            //Stop hang
            mObj.Hang = false;

            //Not found
            throw new Exception("Not found");
        }
        
        private class mObj {
            public long ID;
            public object Instance;
            public static bool Hang;
        }
    }
}