﻿using System;
using System.Collections;

namespace Plywood {
    public partial class GenericMethods {
        private static Random p_RandomSeed = new Random();

        public double sin(double value) { return Math.Sin(value); }
        public double sinh(double value) { return Math.Sinh(value); }
        public double asin(double value) { return Math.Asin(value); }
        public double cos(double value) { return Math.Cos(value); }
        public double cosh(double value) { return Math.Cosh(value); }
        public double acos(double value) { return Math.Acos(value); }
        public double tan(double value) { return Math.Tan(value); }
        public double tanh(double value) { return Math.Tanh(value); }
        public double atan(double value) { return Math.Atan(value); }
        public double atan2(double x, double y) { return Math.Atan2(x, y); }
        public double pow(double x, double y) { return Math.Pow(x, y); }
        public string root(double x, double y) {
            //Define the string version of the return decimal
            string buffer = "";

            //Get the base value (before the decimal point)
            for (ulong c = 0; c < ulong.MaxValue; c++) {
                if (pow(c, y) > x) { c--; buffer = c.ToString(); break; }
                if (pow(c, y) == x) {
                    return c.ToString();
                }
            }

            //Add decimal point
            buffer += ".";

            //Find the rest of the decimal values
            for (int z = 0; z < 1000; z++) {
                for (int c = 0; c < 10; c++) {
                    double bufferVal = Convert.ToDouble(buffer + c);
                    if (pow(bufferVal, y) > x) {
                        buffer += (c - 1);
                        break;
                    }
                    if (pow(bufferVal, y) == x) {
                        buffer += c;
                        return buffer;
                    }
                }
            }
            return buffer;
        }
        public double exp(double value) { return Math.Exp(value); }
        public double floor(double value) { return Math.Floor(value); }
        public double ceiling(double value) { return Math.Ceiling(value); }
        public double truncate(double value) { return Math.Truncate(value); }
        public double max(string definition) {
            //Grab the definition
            IDefinition def = p_State.Script.getDefByName(definition);

            //Get the max value from the definition array
            object[] arr = (object[])def.ArrayList;
            double max = double.MinValue;
            foreach (object o in arr) {
                double d = Convert.ToDouble(o);
                if (d > max) { max = d; }
            }

            //Return the max
            return max;
        }
        public double min(string definition) {
            //Grab the definition
            IDefinition def = p_State.Script.getDefByName(definition);

            //Get the maximum value
            double m = max(definition);

            //Get the minimum value
            object[] array = (object[])def.ArrayList;
            foreach (object o in array) {
                double d = Convert.ToDouble(o);
                if (d < m) { m = d; }
            }

            //Return the minimum value
            return m;

        }
        public double average(string definition) {
            //Grab the definition
            IDefinition def = p_State.Script.getDefByName(definition);

            //Get the average
            object[] array = (object[])def.ArrayList;
            double buffer = 0;
            foreach (object o in array) {
                buffer += Convert.ToDouble(o);
            }
            return buffer = buffer * 1.0f / array.Length;
        }
        public double drand(double min, double max) { 
            //Check the range
            if (min > max || max < min) {
                throw new Exception("Invalid range");
            }

            //Generate a random number
            return min + (p_RandomSeed.NextDouble() * max);
        }
        public long rand(long min, long max) {
            //Just generate a random integer
            return (long)drand((double)min, (double)max);
        }
        public double neg(double value) {
            //Already negative?
            if (value >= 0) { return value; }

            //Return the negative
            return -value;
        }
        public double op(double value) { return -value; }

        public static double pi { get { return Math.PI; } }
        public static double e { get { return Math.E; } }
    }
}