﻿using System;
using System.Collections;
using Microsoft.Win32;

namespace Plywood {
    public partial class GenericMethods {
        public void reg_createKey(string host, string key) { getKey(host).CreateSubKey(key); }
        public void reg_deleteKey(string key) { getKey(key).DeleteSubKey(""); }
        public void reg_setValue(string key, string name, string value) { getKey(key).SetValue(name, value); }
        public void reg_deleteValue(string key, string name) { getKey(key).DeleteValue(name); }
        public string reg_getValue(string key, string name) { return getKey(key).GetValue(name).ToString(); }
        public bool reg_valueExist(string key, string name) {
            //Is the value null?
            try {
                return getKey(key).GetValue(name) != null;
            }
            catch { return false; }
        }
        public bool reg_keyExist(string key) {
            //Attempt to access the key
            try {
                return getKey(key) != null;
            }
            catch { return false; }
        }
        public long reg_getKeys(string key) {
            //Get the registry key key list
            string[] list = getKey(key).GetSubKeyNames();

            //Define the object array to push to the definition
            object[] array = new object[list.Length];
            for (int c = 0; c < list.Length; c++) {
                array[c] = list[c];
            }

            //Push the object array to the current definition
            p_State.CurrentDefinition.ArrayList = (IList)array;
            p_State.CurrentDefinition.IsNumeric = false;
            p_State.ApplyDefinitionGlobal = true;
            return 0;
        }
        public long reg_getValues(string key) {
            //Get the registry value list
            string[] list = getKey(key).GetValueNames();

            //Get the object array from the list 
            object[] array = new object[list.Length];
            for (int c = 0; c < list.Length; c++) {
                array[c] = list[c];
            }

            //Push the array to the definition
            p_State.CurrentDefinition.ArrayList = (IList)array;
            p_State.CurrentDefinition.IsNumeric = false;
            p_State.ApplyDefinitionGlobal = true;
            return 0;
        }

        private RegistryKey getKey(string key) {
            //Grab the base key
            RegistryKey baseKey = null;
            switch (key.Split('/')[0].ToUpper()) {
                case "HKEY_LOCAL_MACHINE": baseKey = Registry.LocalMachine; break;
                case "HKEY_CURRENT_CONFIG": baseKey = Registry.CurrentConfig; break;
                case "HKEY_CLASSES_ROOT": baseKey = Registry.ClassesRoot; break;
                case "HKEY_USERS": baseKey = Registry.Users; break;
                case "HKEY_CURRENT_USER": baseKey = Registry.CurrentUser; break;
                case "HKEY_PERFORMANCE_DATA": baseKey = Registry.PerformanceData; break;
                case "HKEY_DYN_DATA": baseKey = Registry.DynData; break;
                default:
                    throw new Exception("Base key not found");
            }

            //Remove the registry key base
            try { key = key.Substring(key.Split('/')[0].Length + 1); }
            catch { return baseKey; }

            //Open the key and return it
            return baseKey.OpenSubKey(key.Replace("/", "\\\\"), true);
        }
    }
}