﻿using System;
using System.Collections;

namespace Plywood {
    public partial class GenericMethods {
        public string substr(string str, long start, long length) { return str.Substring((int)start, (int)length); }
        public long strlen(string str) { return str.Length; }
        public long split(string str, string seperator) {
            //Check
            if (seperator.Length != 1) {
                throw new Exception("Invalid seperator");
            }

            //Convert the split data to an object array
            string[] sp = str.Split(seperator[0]);
            object[] array = new object[sp.Length];
            for (int c = 0; c < array.Length; c++) {
                array[c] = sp[c];
            }

            //Push the object array to the definition
            p_State.CurrentDefinition.ArrayList = (IList)array;
            p_State.CurrentDefinition.IsNumeric = false;
            p_State.ApplyDefinitionGlobal = true;
            return 0;
        }
        public string replace(string str, string replaceQuery, string replaceDestination) { return str.Replace(replaceQuery, replaceDestination); }
        public string toLower(string str) { 
            return str.ToLower(); }
        public string toUpper(string str) { return str.ToUpper(); }
        public bool isLower(string str) { 
            //Loop through every character
            foreach (char c in str) { 
                //Lower case?
                if (!((int)c >= (int)'a' &&
                      (int)c <= (int)'z')) { return false; }
            }

            //It's lower case
            return true;
        }
        public bool isUpper(string str) { 
            //Loop through every character
            foreach (char c in str) { 
                //Upper case?
                if (!((int)c >= (int)'A' &&
                     (int)c < (int)'Z')) { return false; }
            }

            //It's upper case
            return true;
        }
        public bool isNumeric(string str) { 
            //Attempt to convert to numerical
            try { Convert.ToDouble(str); return true; }
            catch { return false; }
        }
        public string strCreate(string character, long length) {
            //Check the value
            if (character.Length != 1) {
                throw new Exception("Invalid character");
            }

            //Return the new string
            return new string(character[0], (int)length);
        }
        public bool strContains(string str, string contain) { return str.Contains(contain); }
        public long indexOf(string str, string character) { 
            //Check the character
            if (character.Length != 1) {
                throw new Exception("Invalid character");
            }

            //Just call the string clr method
            return str.IndexOf(character[0]);
        }
        public long lastIndexOf(string str, string character) { 
            //Check the character
            if (character.Length != 1) {
                throw new Exception("Invalid character");
            }

            //Get the last index
            return str.LastIndexOf(character[0]);
        }

        public static char newl { get { return '\n'; } }
        public static char copyright { get { return '@'; } }
    }
}