﻿using System;
using System.Threading;

namespace Plywood {
    public partial class GenericMethods {
        private static threadCls[] p_Threads = new threadCls[0];

        public void thread_sleep(long interval) { 
            //Sleep
            Thread.Sleep((int)interval);
        }
        public void thread_destroy(long id) {
            //-1 to represent current?
            if (id == -1) { Thread.CurrentThread.Abort(); return; }

            //Look for the id
            threadCls cls = null;
            foreach (threadCls c in p_Threads) {
                if (c.Id == id) { cls = c; break; }
            }
            if (id == null) { throw new Exception("Id not found"); }

            //Remove the thread
            int ai = 0;
            threadCls[] buffer = new threadCls[p_Threads.Length - 1];
            for (int c = 0; c < p_Threads.Length; c++) {
                if (p_Threads[c].Id == id) { continue; }
                buffer[ai] = p_Threads[c];
                ai++;
            }
            p_Threads = buffer;

            //Stop the thread
            try { cls.Thread.Abort(); }
            catch { }
        }
        public long thread_create() {
            //Grab the scope data
            string scope = p_State.Script.skipScope(p_State.Stream);
            scope = p_State.Script.remUnwantedCharacters(scope);

            //Create a new thread
            Thread t = new Thread(new ThreadStart(delegate {
                //Run the scope
                execute(scope);
            }));
            while (threadCls.Hang) ;
            int maxId = 0;
            foreach (threadCls c in p_Threads) {
                if (c.Id > maxId) { maxId = c.Id; }
            }
            threadCls.Hang = true;
            Array.Resize(ref p_Threads, p_Threads.Length + 1);
            p_Threads[p_Threads.Length - 1] = new threadCls() {
                Thread = t,
                Id = maxId + 1
            };
            threadCls.Hang = false;
            t.Start();
            return maxId + 1;
        }

        private class threadCls {
            public Thread Thread { get; set; }
            public int Id { get; set; }

            public static bool Hang { get; set; }
        }           
    }
}