﻿using System;

namespace Plywood {
    public partial class GenericMethods {
        public string sys_time_str(long ticks) { return new DateTime(ticks).ToString(); }
        public long sys_time() { return DateTime.Now.Ticks; }
        public long sys_time_create(long day, long month, long year, long hour, long minute, long second, long millisecond) {
            //Return the appropriate date time ticks
            return new DateTime((int)year, (int)month, (int)day, (int)hour, (int)minute, (int)second, (int)millisecond).Ticks;
        }
        public long sys_time_day(long ticks) { return new DateTime(ticks).Day; }
        public long sys_time_month(long ticks) { return new DateTime(ticks).Month; }
        public long sys_time_year(long ticks) { return new DateTime(ticks).Year; }
        public long sys_time_hour(long ticks) { return new DateTime(ticks).Hour; }
        public long sys_time_minute(long ticks) { return new DateTime(ticks).Minute; }
        public long sys_time_second(long ticks) { return new DateTime(ticks).Second; }
        public long sys_time_millisecond(long ticks) { return new DateTime(ticks).Millisecond; }
        public long sys_time_addDay(long ticks, long days) { return new DateTime(ticks).AddDays(days).Ticks; }
        public long sys_time_addMonth(long ticks, long months) { return new DateTime(ticks).AddMonths((int)months).Ticks; }
        public long sys_time_addYears(long ticks, long years) { return new DateTime(ticks).AddYears((int)years).Ticks; }
        public long sys_time_addHours(long ticks, long hours) { return new DateTime(ticks).AddHours(hours).Ticks; }
        public long sys_time_addMinutes(long ticks, long minutes) { return new DateTime(ticks).AddMinutes(minutes).Ticks; }
        public long sys_time_addSeconds(long ticks, long seconds) { return new DateTime(ticks).AddSeconds(seconds).Ticks; }
        public long sys_time_addMilliseconds(long ticks, long milliseconds) { return new DateTime(ticks).AddMilliseconds(milliseconds).Ticks; }
        public long sys_time_dayOfWeek(long ticks) { return (long)new DateTime(ticks).DayOfWeek; }
        public long sys_time_dayOfYear(long ticks) { return (long)new DateTime(ticks).DayOfYear; }
        public long sys_time_daysInYear(long year) {
            //Find the number of days in the year
            long buffer = 0;
            while (true) {
                if (new DateTime((int)year, 1, 1).AddDays(buffer).Year != (int)year) {
                    return buffer;
                }
                buffer++;
            }
        }
        public long sys_time_daysInMonth(long month, long year) {
            //Find the day
            long buffer = 1;
            while (true) {
                try {
                    new DateTime((int)year, (int)month, (int)buffer);
                }
                catch {
                    return buffer - 1;
                }
                buffer++;
            }
        }
    }
}